unit SDBCheckUnit;

{$mode ObjFPC}{$H+}

interface

uses SysUtils, Forms, Controls, Dialogs, StdCtrls, Grids, Classes, iniFiles, process, Types, graphics, ExtCtrls, LCLIntf;

type

  { TfrmSDBCheck }
  TfrmSDBCheck = class(TForm)
    btnCheck: TButton;
    btnBearbeiten: TButton;
    PanelPDF: TPanel;
    PanelPDFEdit: TPanel;
    grdDateien: TStringGrid;
    procedure btnCheckClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure grdDateienClick(Sender: TObject);
    procedure grdDateienDrawCell(Sender: TObject; aCol, aRow: Integer; aRect: TRect; aState: TGridDrawState);
    procedure grdDateienEnter(Sender: TObject);
    procedure grdDateienMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure grdDateienSelectCell(Sender: TObject; aCol, aRow: Integer; var CanSelect: Boolean);
    procedure PanelPDFClick(Sender: TObject);

  private
    col, row: LongInt;
    aktZeile: LongInt;
  public
  end;

var frmSDBCheck: TfrmSDBCheck;
    ini: TIniFile;
    pfadName: String;
    PDFProcess: TProcess;

implementation

{$R *.lfm}


{ TfrmSDBCheck }

procedure TfrmSDBCheck.FormCreate(Sender: TObject);
var pdfName: String;
begin
  btnCheckClick(Sender);

  PDFProcess := TProcess.Create(nil);
  aktZeile := 1;
  pdfName := '1 Testartikel v1.pdf';
  //PDFProcess.Executable := 'pdf\SumatraPDF.exe';
  //With PDFProcess.Parameters do
  //begin
  //  add('-plugin ' + IntToStr(PanelPDFEdit.Handle));
  //  add('"' + pdfName + '"');
  //  add('-search "Version"');
  //  add('-zoom "fit page"');
  //  add('-view "single page"');
  //end;
  PDFProcess.CommandLine := 'SumatraPDF.exe'
                          + ' -plugin ' + IntToStr(PanelPDFEdit.Handle)
                          + ' "' + pdfName + '"'
                          + ' -search "Version"'
                          + ' -view "single page"';
  PDFProcess.Execute;
  PanelPDFEdit.Enabled := false;
end;

procedure TfrmSDBCheck.grdDateienClick(Sender: TObject);
begin
  writeln('Hier komme ich nicht rein...tststs');
  PanelPDFEdit.Enabled := false;
end;

procedure TfrmSDBCheck.grdDateienDrawCell(Sender: TObject; aCol, aRow: Integer; aRect: TRect; aState: TGridDrawState);
var //ts: TTextStyle;
    txt: String;
begin
  if (aCol > 0) AND (aRow > 0) then
  begin
    if grdDateien.Cells[0, aRow] = 'g' then
      grdDateien.Canvas.Brush.Color := clCream
    else
      grdDateien.Canvas.Brush.Color := clWhite;
    grdDateien.Canvas.FillRect(aRect);

    //ts.Alignment := TAlignment(taLeftJustify);
    //ts.Layout := TTextLayout(tlCenter);
    aRect.Width:=aRect.Width - 5;  // right margin...
    txt := grdDateien.Cells[aCol, aRow];
    grdDateien.Canvas.TextRect(aRect, aRect.Left, aRect.Top, grdDateien.Cells[aCol, aRow]);
    //grdDateien.Canvas.TextRect(aRect, aRect.Left, aRect.Top, grdDateien.Cells[aCol, aRow], ts);
  end;
end;

procedure TfrmSDBCheck.grdDateienEnter(Sender: TObject);
begin
end;

procedure TfrmSDBCheck.grdDateienMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  grdDateien.MouseToCell(x, y, col, row);
end;

procedure TfrmSDBCheck.grdDateienSelectCell(Sender: TObject; aCol, aRow: Integer; var CanSelect: Boolean);
begin
  col := aCol;
  row := aRow;
  writeln(row, ' ', col);
  if aktZeile <> Row then
  begin
    aktZeile := Row;
    if PDFProcess <> nil then
    begin
      // Hilfe zu Sumatra Kommandozeile: https://www.sumatrapdfreader.org/docs/Command-line-arguments
      //PDFProcess.Executable := 'pdf\SumatraPDF.exe';
      //With PDFProcess.Parameters do
      //begin
      //  add('-plugin ' + IntToStr(PanelPDFEdit.Handle));
      //  add('"' + pfadName + grdDateien.Cells[3, Row] + '"');
      //  add('-search "Version"');
      //  add('-zoom "fit page"');
      //  add('-view "single page"');
      //end;
      PDFProcess.CommandLine := 'SumatraPDF.exe'
                              + ' -reuse-instance'
                              + ' -plugin ' + IntToStr(PanelPDFEdit.Handle)
                              + ' "' + pfadName + grdDateien.Cells[3, Row] + '"'
                                + ' -search "Version"'
                              + ' -zoom "fit page"'
                              + ' -view "single page"';
      PDFProcess.Execute;
      PanelPDFEdit.Enabled := false;
      CanSelect := true;
    end;
  end;
end;

procedure TfrmSDBCheck.PanelPDFClick(Sender: TObject);
begin
  PanelPDFEdit.Enabled := true;
end;

procedure TfrmSDBCheck.btnCheckClick(Sender: TObject);
const artArray: array[1..4] of integer = (1, 2, 3, 7921);
var pdfName: String;
    i, j: Integer;
    suchDatei: TSearchRec;
    ary: array [1..10] of String;
    aryAnz: Integer;
    gerade: char;

begin
  grdDateien.RowCount := 1;
  gerade := 'g';
  for j := 1 to 4 do
  begin
    aryAnz := 0;
    pdfName := IntToStr(artArray[j]) + '*.pdf';
    if FindFirst(pdfName, faAnyFile, suchDatei) = 0 then
    begin
      repeat
        aryAnz := aryAnz + 1;
        ary[aryAnz] := suchDatei.Name;
      until FindNext(suchDatei) <> 0;
      FindClose(suchDatei);
    end;

    if aryAnz > 1 then
    begin
      for i := 1 to aryAnz do
      begin
        grdDateien.RowCount := grdDateien.RowCount + 1;
        if i = 1 then
        begin
          grdDateien.Cells[1, grdDateien.RowCount-1] := IntToStr(artArray[j]);
          grdDateien.Cells[2, grdDateien.RowCount-1] := ary[i];
        end;
        grdDateien.Cells[0, grdDateien.RowCount-1] := gerade;
        grdDateien.Cells[3, grdDateien.RowCount-1] := ary[i];
      end;
      if gerade = 'g' then
        gerade := ' '
      else
        gerade := 'g';
    end;
  end;
end;

end.
